package sort;

/**
 * 
 * Modifications:
 * 
 * Changed array from type Object ton int
 * Removed Order interface which was used for comparisons
 * wrote main functions
 * added isSorted functions
 * changed loop code in buildHeap to avoid i = 0 and i-- which stalls computation there
 *
 * bits: 4, heapsize 9
 */
public class HeapSort extends Sort {

	private int n;

	public HeapSort(int[] objects) {
	        super(objects);
	        n = objects.length;
	        buildHeap();
	        while (n > 0) removeMax();
	}

	public static void main(String[] args) 
	{
		int[] array = new int[3];
		for (int i = 0; i < array.length; i++) {
			array[i] = Integer.parseInt("");
		}
		assert(new HeapSort(array).isSorted());
	}
	
	private boolean isSorted()
	{
		for (int i = 0; i < objects.length - 1; i++) {
			if (objects[i] > objects[i + 1]) {
				return false;
			}
		}
		return true;
	}

	private void buildHeap() {
	        for (int i = n/2-1; i > 0; i--) {
	                siftdown(i);
	        }
	        siftdown(0);
	}       
	private void siftdown(int pos) {
	        while (! isLeaf(pos)) {
	                int j = leftChild(pos);
	                if ((j < n-1) && objects[j] < objects[j+1]) 
	                        j++;
	                if (! (objects[pos] < objects[j])) return;
	                swap(pos, j);
	                pos = j;
	        }
	}
	private int parent(int pos) {
	        return (pos-1)/2;
	}
	private int leftChild(int pos) {
	        return 2*pos+1;
	}
	private int rightChild(int pos) {
	        return 2*pos+2;
	}
	private boolean isLeaf(int pos) {
	        return (pos >= n/2) && (pos < n);
	}
	private void swap(int x, int y) {
	        int obj = objects[x];
	        objects[x] = objects[y];
	        objects[y] = obj;
	}
	
	private int removeMax() {
		assert(n > 0);
	        swap(0, --n);
	        if (n != 0) siftdown(0);
	        return objects[n];
	}
	
	
	
}
