package sort;

import de.uni_stuttgart.fmi.szs.jmoped.annotation.PDSParameterBits;

public class MergeSort {
	
	protected int toSort[];
	protected int swapSpace[];
	
	public static void main(String[] args)
	{
		int[] array = new int[2];
		for (int i = 0; i < array.length; i++) {
			array[i] = Integer.parseInt("");
		}
		new MergeSort().sort(array);
	}
	
	@PDSParameterBits(2)
	public void sort(int array[]) {
		if (array != null && array.length > 1) {
			int maxLength;
			
			maxLength = array.length;
			swapSpace = new int[maxLength];
			toSort = array;
			this.mergeSort(0, maxLength - 1);
			swapSpace = null;
			toSort = null;
		}
	}
	
	protected void mergeSort(int begin, int end) {
		if (begin != end) {
			int mid;
			
			mid = (begin + end) / 2;
			this.mergeSort(begin, mid);
			this.mergeSort(mid + 1, end);
			this.merge(begin, mid, end);
		}
	}
	
	protected void merge(int begin, int middle, int end) {
		int firstHalf, secondHalf, count;
		
		firstHalf = count = begin;
		secondHalf = middle + 1;
		while ( (firstHalf <= middle) && (secondHalf <= end)) {
			if (toSort[secondHalf] < toSort[firstHalf]) {
				swapSpace[count++] = toSort[secondHalf++];
			}
			else {
				swapSpace[count++] = toSort[firstHalf++];
			}
		}
		if (firstHalf <= middle) {
			while (firstHalf <= middle) {
				swapSpace[count++] = toSort[firstHalf++];
			}
		}
		else {
			while (secondHalf <= end) {
				swapSpace[count++] = toSort[secondHalf++];
			}
		}
		for (count = begin; count <= end; count++) {
			toSort[count] = swapSpace[count];
		}
	}
}


